<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" /><meta name="generator" content="Docutils 0.18.1: http://docutils.sourceforge.net/" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Cavity flow &mdash; cflowpy Jule 2023 documentation</title>
      <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="../_static/css/theme.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script src="../_static/jquery.js"></script>
        <script src="../_static/_sphinx_javascript_frameworks_compat.js"></script>
        <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
        <script src="../_static/doctools.js"></script>
        <script src="../_static/sphinx_highlight.js"></script>
        <script async="async" src="https://cdn.jsdelivr.net/npm/mathjax@3/es5/tex-mml-chtml.js"></script>
    <script src="../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="Integrator" href="../integrator.html" />
    <link rel="prev" title="Pipe with a backward facing step" href="pipe_with_a_backward_facing_step.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../index.html" class="icon icon-home">
            cflowpy
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">cflowpy:</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../tutorial.html">Tutorial</a></li>
<li class="toctree-l1"><a class="reference internal" href="../grid.html">Grid</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="../physical_problem.html">Physical Problem</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="../physical_problem.html#constructor">Constructor</a></li>
<li class="toctree-l2"><a class="reference internal" href="../physical_problem.html#system-initialisation">System initialisation</a></li>
<li class="toctree-l2"><a class="reference internal" href="../physical_problem.html#boundary-conditions">Boundary Conditions</a></li>
<li class="toctree-l2 current"><a class="reference internal" href="../physical_problem.html#subclasses">Subclasses</a><ul class="current">
<li class="toctree-l3"><a class="reference internal" href="pipe_flow.html">Pipe flow</a></li>
<li class="toctree-l3"><a class="reference internal" href="pipe_flow.html#pressure-driven-pipe-flow">Pressure driven pipe flow</a></li>
<li class="toctree-l3"><a class="reference internal" href="pipe_with_a_backward_facing_step.html">Pipe with a backward facing step</a></li>
<li class="toctree-l3 current"><a class="current reference internal" href="#">Cavity flow</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#constructor">Constructor</a></li>
<li class="toctree-l4"><a class="reference internal" href="#system-initialisation">System initialisation</a></li>
<li class="toctree-l4"><a class="reference internal" href="#boundary-conditions">Boundary Conditions</a></li>
<li class="toctree-l4"><a class="reference internal" href="#expected-results">Expected Results</a></li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../integrator.html">Integrator</a></li>
<li class="toctree-l1"><a class="reference internal" href="../system.html">Solving the incompressible Navier-Stokes Equation</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../index.html">cflowpy</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../physical_problem.html">Physical Problem</a></li>
      <li class="breadcrumb-item active">Cavity flow</li>
      <li class="wy-breadcrumbs-aside">
            <a href="../_sources/PhysicalProblems/cavity_flow.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="cavity-flow">
<h1>Cavity flow<a class="headerlink" href="#cavity-flow" title="Permalink to this heading"></a></h1>
<div class="line-block">
<div class="line">For the cavity flow a domain with three rigid walls is faced.</div>
<div class="line">On three of the four walls the no-slip condition is applied
and on the fourth wall a lid is moving with a tangential unit
velocity.</div>
</div>
<dl class="py class">
<dt class="sig sig-object py">
<em class="property"><span class="pre">class</span><span class="w"> </span></em><span class="sig-prename descclassname"><span class="pre">src.</span></span><span class="sig-name descname"><span class="pre">Cavity_flow</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">velocity</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">side</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span></span></em><span class="sig-paren">)</span></dt>
<dd><p>This class is used to simulate a lid-driven cavity flow.</p>
<p>It is dealt with a cavity consisting of three rigid walls
with no-slip conditions and a lid moving with a tangential unit velocity.
For the pressure there are used Dirichlet boundary conditions on the side
of the lid and Neumann boundary conditions on all other sides.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>velocity</strong> (<em>float</em>) – Velocity of the lid</p></li>
<li><p><strong>side</strong> (<em>string</em>) – Side of the domain on which the lid is moving</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<section id="constructor">
<h2>Constructor<a class="headerlink" href="#constructor" title="Permalink to this heading"></a></h2>
<dl class="py method">
<dt class="sig sig-object py" id="src.Cavity_flow.__init__">
<span class="sig-prename descclassname"><span class="pre">Cavity_flow.</span></span><span class="sig-name descname"><span class="pre">__init__</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">velocity</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">float</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">side</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">str</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#src.Cavity_flow.__init__" title="Permalink to this definition"></a></dt>
<dd><p>Constructor</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>velocity</strong> (<em>float</em>) – Velocity of the lid</p></li>
<li><p><strong>side</strong> (<em>str</em>) – Side of the domain on which the lid is moving
Can be one of the following: left, bottom, right or top</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<div class="line-block">
<div class="line">Typically, in the case of a cavity flow, a quadratic domain would be used.</div>
<div class="line">By initializing the physical domain, this should be kept in mind.</div>
<div class="line">Large differences between the number of grid points or between the domain
sizes in x and y-direction can lead to inaccurate results.</div>
</div>
<blockquote>
<div><div class="admonition hint">
<p class="admonition-title">Hint</p>
<div class="line-block">
<div class="line">The number of Cells for each direction should be between
<span class="math notranslate nohighlight">\((x_n-x_0)\cdot 2 \leq n_i \leq (x_n-x_0)\cdot 50\)</span> where
<span class="math notranslate nohighlight">\(x_n\)</span> is the end of the domain, <span class="math notranslate nohighlight">\(x_0\)</span> the begin
of the domain and <span class="math notranslate nohighlight">\(n_i\)</span> the number of cells, for each dimension.</div>
<div class="line"><strong>Note:</strong> This might differ for some specific discretization like very
small or very large computational domains.</div>
</div>
</div>
</div></blockquote>
<div class="line-block">
<div class="line">A possible initialisation could be:</div>
</div>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="n">physical_problem</span> <span class="o">=</span> <span class="n">src</span><span class="o">.</span><span class="n">Cavity_flow</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="s2">&quot;top&quot;</span><span class="p">)</span>
</pre></div>
</div>
<div class="line-block">
<div class="line">In this case the lid is moving with a velocity of 1 from the left to the
right on top of the domain.</div>
</div>
</section>
<section id="system-initialisation">
<h2>System initialisation<a class="headerlink" href="#system-initialisation" title="Permalink to this heading"></a></h2>
<div class="line-block">
<div class="line">For the cavity flow the system is initialised with the boundary Conditions
and has no special construction for the first time step.</div>
</div>
</section>
<section id="boundary-conditions">
<h2>Boundary Conditions<a class="headerlink" href="#boundary-conditions" title="Permalink to this heading"></a></h2>
<div class="line-block">
<div class="line">Dirichlet Boundary conditions, in form of the no-slip condition, are applied
to three of the four walls for the velocity and Neumann boundary conditions
for the pressure.</div>
<div class="line">On the fourth side of the domain the the lid is moving with a tangential
unit velocity.</div>
<div class="line">At this side of the domain Dirichlet boundary conditions are applied for
the velocity and for the pressure.</div>
</div>
<dl class="py method">
<dt class="sig sig-object py" id="src.Cavity_flow.apply_bcs_velocity">
<span class="sig-prename descclassname"><span class="pre">Cavity_flow.</span></span><span class="sig-name descname"><span class="pre">apply_bcs_velocity</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">u</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">v</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#src.Cavity_flow.apply_bcs_velocity" title="Permalink to this definition"></a></dt>
<dd><p>Applies the boundary conditions for the velocity field.</p>
<p>Applies Dirichlet boundary conditions on each side of the domain,</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>u</strong> (<em>np.ndarray</em>) – velocity field in x-direction</p></li>
<li><p><strong>v</strong> (<em>np.ndarray</em>) – velocity field in y-direction</p></li>
</ul>
</dd>
<dt class="field-even">Raises<span class="colon">:</span></dt>
<dd class="field-even"><p><strong>TypeError</strong> – If one of the inputs is no numpy ndarray</p>
</dd>
<dt class="field-odd">Returns<span class="colon">:</span></dt>
<dd class="field-odd"><p>Velocity fields after applying the boundary conditions</p>
</dd>
<dt class="field-even">Return type<span class="colon">:</span></dt>
<dd class="field-even"><p>np.ndarray, np.ndarray</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="src.Cavity_flow.apply_bcs_pressure">
<span class="sig-prename descclassname"><span class="pre">Cavity_flow.</span></span><span class="sig-name descname"><span class="pre">apply_bcs_pressure</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">p</span></span><span class="p"><span class="pre">:</span></span><span class="w"> </span><span class="n"><span class="pre">ndarray</span></span></em><span class="sig-paren">)</span><a class="headerlink" href="#src.Cavity_flow.apply_bcs_pressure" title="Permalink to this definition"></a></dt>
<dd><p>Applies the boundary conditions for the pressure field</p>
<p>Applies Dirichlet boundary conditions on the side of the lid
and Neumann boundary conditions on all other sides.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters<span class="colon">:</span></dt>
<dd class="field-odd"><p><strong>p</strong> (<em>np.ndarray</em>) – pressure field</p>
</dd>
<dt class="field-even">Raises<span class="colon">:</span></dt>
<dd class="field-even"><p><strong>TypeError</strong> – If the pressure field is no numpy ndarray</p>
</dd>
<dt class="field-odd">Returns<span class="colon">:</span></dt>
<dd class="field-odd"><p>Pressure field after applying the boundary conditions</p>
</dd>
<dt class="field-even">Return type<span class="colon">:</span></dt>
<dd class="field-even"><p>np.ndarray</p>
</dd>
</dl>
</dd></dl>

</section>
<section id="expected-results">
<h2>Expected Results<a class="headerlink" href="#expected-results" title="Permalink to this heading"></a></h2>
<div class="line-block">
<div class="line">The velocity profile across the vertical centerline of the cavity is
expected to be parabolic, for the case of the lid moving at the top
or bottom edge of the domain.</div>
<div class="line">If the lid is moving at the left or right side, the velocity profile
is expected to be parabolic across the horizontal centerline.</div>
<div class="line">Furthermore, the flow is expected to be symmetric along the centerlines.</div>
<div class="line">The streamlines are expected to be clockwise, if the lid is moving on the
top side of the domain to the right direction,
which is creating a clockwise velocity profile.</div>
<div class="line">If the lid is moving from right to left, the velocity profile is expected
to be counter clockwise.</div>
<div class="line">Additionally, the pressure is expected to be higher on the side where the
lid is moving towards and to be lower on the side where it comes from.</div>
<div class="line">All in all, the simulation, as already done in the <a class="reference internal" href="../tutorial.html#tutorial"><span class="std std-ref">Tutorial</span></a>, can be
run with:</div>
</div>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">cflowpy</span> <span class="k">as</span> <span class="nn">cf</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">physical_problem_cavity</span> <span class="o">=</span> <span class="n">cf</span><span class="o">.</span><span class="n">Cavity_flow</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="s2">&quot;top&quot;</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">system</span> <span class="o">=</span> <span class="n">cf</span><span class="o">.</span><span class="n">System</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="mi">2</span><span class="p">,</span> <span class="mi">30</span><span class="p">,</span>
<span class="go">                        0, 2, 30,</span>
<span class="go">                        0.1, 1,</span>
<span class="go">                        physical_problem_cavity)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">u</span><span class="p">,</span> <span class="n">v</span><span class="p">,</span> <span class="n">p</span> <span class="o">=</span> <span class="n">system</span><span class="o">.</span><span class="n">solve</span><span class="p">(</span><span class="mf">0.01</span><span class="p">,</span> <span class="mi">5</span><span class="p">)</span>
</pre></div>
</div>
<p>and visualized with:</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span> <span class="n">fig</span> <span class="o">=</span> <span class="n">system</span><span class="o">.</span><span class="n">contourfigure</span><span class="p">(</span><span class="n">u</span><span class="p">,</span> <span class="n">v</span><span class="p">,</span> <span class="n">p</span><span class="p">,</span>
<span class="go">                                cmap=&quot;coolwarm&quot;,</span>
<span class="go">                                title=&quot;Lid-driven cavity flow&quot;)</span>
</pre></div>
</div>
<a class="reference internal image-reference" href="../_images/Cavity_streamline.png"><img alt="../_images/Cavity_streamline.png" src="../_images/Cavity_streamline.png" style="width: 600px;" /></a>
</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="pipe_with_a_backward_facing_step.html" class="btn btn-neutral float-left" title="Pipe with a backward facing step" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="../integrator.html" class="btn btn-neutral float-right" title="Integrator" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2023, Jan Habscheid.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>